﻿using System;
using AVFoundation;
using CloudKit;
using CoreAnimation;
using CoreData;
using CoreFoundation;
using CoreGraphics;
using CoreImage;
using CoreLocation;
using CoreVideo;
using FileProvider;
using Foundation;
using IOSurface;
using ImageIO;
using Intents;
using Metal;
using ObjCRuntime;
using OpenGLES;
using Security;
using UIKit;

namespace InfColorPicker
{
  
// @interface InfColorBarView : UIView
[BaseType(typeof(UIView))]
interface InfColorBarView
{
}

// @interface InfColorBarPicker : UIControl
[BaseType(typeof(UIControl))]
interface InfColorBarPicker
{
    // @property (nonatomic) float value;
    [Export("value")]
    float Value { get; set; }
}

// @interface InfColorIndicatorView : UIView
[BaseType(typeof(UIView))]
interface InfColorIndicatorView
{
    // @property (nonatomic) UIColor * color;
    [Export("color", ArgumentSemantic.Assign)]
    UIColor Color { get; set; }
}

// @interface InfColorPickerController : UIViewController
[BaseType(typeof(UIViewController))]
interface InfColorPickerController
{
    // +(InfColorPickerController *)colorPickerViewController;
    [Static]
    [Export("colorPickerViewController")]
    InfColorPickerController ColorPickerViewController { get; }

    // +(CGSize)idealSizeForViewInPopover;
    [Static]
    [Export("idealSizeForViewInPopover")]
    CGSize IdealSizeForViewInPopover { get; }

    // -(void)presentModallyOverViewController:(UIViewController *)controller;
    [Export("presentModallyOverViewController:")]
    void PresentModallyOverViewController(UIViewController controller);

    // @property (nonatomic) UIColor * sourceColor;
    [Export("sourceColor", ArgumentSemantic.Assign)]
    UIColor SourceColor { get; set; }

    // @property (nonatomic) UIColor * resultColor;
    [Export("resultColor", ArgumentSemantic.Assign)]
    UIColor ResultColor { get; set; }

    [Wrap("WeakDelegate")]
    InfColorPickerControllerDelegate Delegate { get; set; }

    // @property (nonatomic, weak) id<InfColorPickerControllerDelegate> delegate;
    [NullAllowed, Export("delegate", ArgumentSemantic.Weak)]
    NSObject WeakDelegate { get; set; }
}

    // @protocol InfColorPickerControllerDelegate
[BaseType(typeof(NSObject))]
[Model]
interface InfColorPickerControllerDelegate
{
    // @optional -(void)colorPickerControllerDidFinish:(InfColorPickerController *)controller;
    [Export("colorPickerControllerDidFinish:")]
    void ColorPickerControllerDidFinish(InfColorPickerController controller);

    // @optional -(void)colorPickerControllerDidChangeColor:(InfColorPickerController *)controller;
    [Export("colorPickerControllerDidChangeColor:")]
    void ColorPickerControllerDidChangeColor(InfColorPickerController controller);
}

// @interface InfColorPickerNavigationController : UINavigationController
[BaseType(typeof(UINavigationController))]
interface InfColorPickerNavigationController
{
}

// @interface InfColorSquareView : UIImageView
[BaseType(typeof(UIImageView))]
interface InfColorSquareView
{
    // @property (nonatomic) float hue;
    [Export("hue")]
    float Hue { get; set; }
}

// @interface InfColorSquarePicker : UIControl
[BaseType(typeof(UIControl))]
interface InfColorSquarePicker
{
    // @property (nonatomic) float hue;
    [Export("hue")]
    float Hue { get; set; }

    // @property (nonatomic) CGPoint value;
    [Export("value", ArgumentSemantic.Assign)]
    CGPoint Value { get; set; }
}

// @interface InfSourceColorView : UIControl
[BaseType(typeof(UIControl))]
interface InfSourceColorView
{
    // @property (nonatomic) BOOL trackingInside;
    [Export("trackingInside")]
    bool TrackingInside { get; set; }
}
}
